unit About;
(*##*)
(*******************************************************************
*                                                                 *
*   A  B  O  U  T              EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   common EPAGER about form (display logo at startup all program)*
*   Conditional defines: NODEBUG or ECLIENT, EOPER, EGATE, EDICT   *
*     EXLAT                                                       *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Oct 15 1998                                    *
*   Lines        : 92                                              *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses Classes, Forms, SysUtils, Graphics, Controls, StdCtrls, ExtCtrls,
  PCommon;

type
  TAboutBox = class(TForm)
    LWrongWay: TLabel;
    LUser: TLabel;
    LCompany: TLabel;
    LSerial: TLabel;
    LLoading: TLabel;
    LBottomLine1: TLabel;
    LBottomLine2: TLabel;
    Image1: TImage;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}
uses
  Dialogs;

procedure TAboutBox.FormActivate(Sender: TObject);
var
  Picture: String;
begin
{$IFDEF NODEBUG}
  Picture:= ABOUTPICTURE;
{$ENDIF}
{$IFDEF ECLIENT}
  Picture:= ABOUTCLIPICTURE;
{$ENDIF}
{$IFDEF EOPER}
  Picture:= ABOUTOPERPICTURE;
{$ENDIF}
{$IFDEF EGATE}
  Picture:= ABOUTGATEPICTURE;
{$ENDIF}
{$IFDEF EDICT}
  Picture:= ABOUTDICTPICTURE;
{$ENDIF}
{$IFDEF EXLAT}
  Picture:= ABOUTXLATPICTURE;
{$ENDIF}
  if FileExists(Picture) then begin
    try
      Image1.Picture.LoadFromFile(PICTURE);
    except
    end;
  end else begin
    LWrongWay.Visible:= True;
    ShowMessage(',    , .');
  end;
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  LUser.Caption:=    pgGetRegString('Name', '  ');
  LCompany.Caption:= pgGetRegString('Company', '  ');
  LSerial.Caption:=  pgGetRegString('Serial', '(.  README.TXT   )');
end;

end.
