unit Client;
(*##*)
(*******************************************************************
*                                                                 *
*   C  L  I  E  N  T           EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Client- part of EPager. (Office)                              *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 218                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

{ Employee table DLL project implementaton.
  DLL functions:
    Index Name               Description
    1     ViewEmployeeTable  View tmployee table
    2     ...
}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables,
  StdCtrls, Mask, TabNotBk,
  FileCtrl, Menus, DBLookup, Inifiles, Tabs, Buttons, ToolWin, ComCtrls,
  // RXDBCtrl,RXCalc,RXClock,ToolEdit,
  PCommon, util1, About;

const
  { 3 kind of search }
  SEARCHBYNAMES = 0;
  SEARCHBYID    = 1;
  SEARCHBYDATE  = 2;

  { TabbedNotebook PageIndex constants
  }
  tbCARD = 0;
  tbLIST = 1;
  tbFind = 2;

type
  SOB = set of Byte;
  TFormClient = class(TForm)
    TNVis: TTabbedNotebook;
    Label5: TLabel;
    Label33: TLabel;
    Label39: TLabel;
    Label38: TLabel;
    Label31: TLabel;
    Label34: TLabel;
    Label43: TLabel;
    Label42: TLabel;
    Label41: TLabel;
    Label30: TLabel;
    Label29: TLabel;
    Label7: TLabel;
    DBNavigator: TDBNavigator;
    Panel3: TPanel;
    CBSQLs: TComboBox;
    FLBoxSQL: TFileListBox;
    BSQLDoIt: TButton;
    MSQL: TMemo;
    BPrintList: TButton;
    DBGSearchVisitor: TDBGrid;
    TabSetSearch: TTabSet;
    Panel4: TPanel;
    Bevel2: TPanel;
    Bevel3: TPanel;
    Bevel4: TPanel;
    TabSetVisits: TTabSet;
    DBGridVisits: TDBGrid;
    DBNavigator1: TDBNavigator;
    MEOT: TMaskEdit;
    MEFAM: TMaskEdit;
    MEIM: TMaskEdit;
    MEOrgName: TMaskEdit;
    MEOrgNo: TMaskEdit;
    MEBillDog: TMaskEdit;
    MEBillSer: TMaskEdit;
    MEBillName: TMaskEdit;
    BSearch: TButton;
    BNewVisitor: TButton;
    BRegister: TButton;
    DBGCalls: TDBGrid;
    DBNavigator2: TDBNavigator;
    TabSetCalls: TTabSet;
    CoolBar1: TCoolBar;
    StatusBar1: TStatusBar;
    DtDBEServiceFrom: TDBEdit;
    DtDBEServiceTo: TDBEdit;
    DBCBBillName: TDBComboBox;
    DBEBillSer: TDBEdit;
    DBEBillDog: TDBEdit;
    DBEBillNo: TDBEdit;
    Label23: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label15: TLabel;
    Label26: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    TBarBill: TToolBar;
    TBEditServList: TToolButton;
    DBCBRepair: TDBCheckBox;
    Label51: TLabel;
    DBCBRepairMan: TDBComboBox;
    DtDBERepairFrom: TDBEdit;
    DBCBRepairDesc: TDBComboBox;
    Panel1: TPanel;
    CBSearch: TComboBox;
    CBInService: TDBCheckBox;
    BChangeAbNo: TButton;
    ToolBar3: TToolBar;
    BMkPager: TToolButton;
    BPagerExchange: TToolButton;
    BRmPager: TToolButton;
    GBInfoChannel: TGroupBox;
    DBGInfoChannels: TDBGrid;
    DBNavigator3: TDBNavigator;
    EditCAP: TDBEdit;
    Label4: TLabel;
    GBOneCapList: TGroupBox;
    DBGOtherCAPs: TDBGrid;
    GroupBox1: TGroupBox;
    DBGServiceDescList: TDBGrid;
    DBGAbServices: TDBGrid;
    ToolBar2: TToolBar;
    BAddService: TToolButton;
    BSubService: TToolButton;
    HeaderControl1: THeaderControl;
    ToolBar4: TToolBar;
    TBMkInfoChanByService: TToolButton;
    TBRmInfoChanByService: TToolButton;
    GroupBox3: TGroupBox;
    DBCBPgModel: TDBComboBox;
    Label11: TLabel;
    Label48: TLabel;
    DtDBEWarranty: TDBEdit;
    DtDBEPgDate: TDBEdit;
    DBCBReseller: TDBComboBox;
    Label27: TLabel;
    GroupBox4: TGroupBox;
    DBCBDOCNAME: TDBComboBox;
    Label12: TLabel;
    DBEditDOCSer: TDBEdit;
    DBEDocNum: TDBEdit;
    DBEDocKem: TDBEdit;
    DtDBEWhen: TDBEdit;
    Label35: TLabel;
    Label1: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    GroupBox5: TGroupBox;
    DBEZone: TDBEdit;
    DBEPost: TDBEdit;
    Label6: TLabel;
    Label52: TLabel;
    DBCBCity: TDBComboBox;
    DBEStreet: TDBEdit;
    DBEBuilding: TDBEdit;
    DBEPhone: TDBEdit;
    DBETmpPhone: TDBEdit;
    DBETmpBuilding: TDBEdit;
    DBETmpStreet: TDBEdit;
    DBCBTempAddress: TDBCheckBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label19: TLabel;
    GroupBox6: TGroupBox;
    DBCBServiceCat: TDBComboBox;
    DtDBEBirth: TDBEdit;
    DBCBBusiness: TDBComboBox;
    DBCBOrgName: TDBComboBox;
    DBEOrgNo: TDBEdit;
    DBCBOrg: TDBCheckBox;
    Label24: TLabel;
    Label25: TLabel;
    Label2: TLabel;
    DBRadioGroup1: TDBRadioGroup;
    Label16: TLabel;
    GroupBox7: TGroupBox;
    DBENameF: TDBEdit;
    DBENameI: TDBEdit;
    DBENameO: TDBEdit;
    GroupBox8: TGroupBox;
    DBTCreated: TDBText;
    DBTUpdated: TDBText;
    DBTHCode: TDBText;
    DBTTabNo: TDBText;
    BMoreInformation: TButton;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    N3: TMenuItem;
    MFileExit: TMenuItem;
    MOptions: TMenuItem;
    MCommonOptions: TMenuItem;
    MOptionsQuickDictUse: TMenuItem;
    MOptionsUpdateDict: TMenuItem;
    N1: TMenuItem;
    MOptionsStore: TMenuItem;
    Image1: TImage;
    DBENickName: TDBEdit;
    DBEPasswd: TDBEdit;
    MView: TMenuItem;
    MViewShowPasswd: TMenuItem;
    Image2: TImage;
    DBGQuery: TDBGrid;
    Label3: TLabel;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    BRelations: TButton;
    DbTAbonent: TDBText;
    MD1: TMenuItem;
    procedure TNVisChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure BSQLDoItClick(Sender: TObject);
    procedure CBSQLsChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure popPhotoDeleteClick(Sender: TObject);
    procedure UpdateVisibles(Sender: TObject);
    procedure BPrintListClick(Sender: TObject);
    procedure TabSetSearchChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure ToggleSearch1(Sender: TObject);
    procedure ToggleSearch2(Sender: TObject);
    procedure ToggleSearch3(Sender: TObject);
    procedure BSearchClick(Sender: TObject);
    procedure BNewVisitorClick(Sender: TObject);
    procedure TableVisitorAfterInsert(DataSet: TDataset);
    procedure TableVisitorCalcFields(DataSet: TDataset);
    procedure TableVisitsAfterInsert(DataSet: TDataset);
    procedure EditOTChange(Sender: TObject);
    procedure BRegisterClick(Sender: TObject);
    procedure DSVisitsDataChange(Sender: TObject; Field: TField);
    procedure DBETmpStreetChange(Sender: TObject);
    procedure TableVisitorBeforeDelete(DataSet: TDataset);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DtDBEDateKeyPress(Sender: TObject; var Key: Char);
    procedure DtDBEWhenKeyPress(Sender: TObject; var Key: Char);
    procedure DBEPhoneKeyPress(Sender: TObject; var Key: Char);
    procedure DBGSearchVisitorDblClick(Sender: TObject);
    procedure FatherNameClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TabSetVisitsChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure TabSetCallsChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure DisplayHint(Sender: TObject);
    procedure MFileExitClick(Sender: TObject);
    procedure BEditRelationsClick(Sender: TObject);
    procedure BAddServiceClick(Sender: TObject);
    procedure BSubServiceClick(Sender: TObject);
    procedure CBSearchKeyPress(Sender: TObject; var Key: Char);
    procedure BChangeAbNoClick(Sender: TObject);
    procedure TBMkInfoChanByServiceClick(Sender: TObject);
    procedure TBRmInfoChanByServiceClick(Sender: TObject);
    procedure HeaderControl1SectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure BMoreInformationClick(Sender: TObject);
    procedure MCommonOptionsClick(Sender: TObject);
    procedure MOptionsQuickDictUseClick(Sender: TObject);
    procedure MOptionsStoreClick(Sender: TObject);
    procedure MOptionsUpdateDictClick(Sender: TObject);
    procedure MViewShowPasswdClick(Sender: TObject);
    procedure CBSearchClick(Sender: TObject);
    procedure MViewEmployeeClick(Sender: TObject);
  private
    { Private declarations }
    FirstActivate: Boolean;
    AliasCyrList: TStringList;
    AllreadyRegistered: Boolean;
    AutoSexDetect: Boolean;
    SessionInserted: LongInt;
    CLIENTLABELS: String[255];
    VISITSLABELS: String[255];
    CALLSLABELS: String[255];
    PhoneDelimiter,
    DateDelimiter: String[4];
    ServicesSet: SOB;
    procedure FillDBCB(const SQLFN: String; List: TStrings; const ACaption: String);
    { show what search was selected }
    procedure BevelStyle(Id: Word);
    { fill "Type of employee lists" combobox
    used entire second line in SQL query file
    return qty of SQL scripts,
    0  - no .SQL found    -1 - errors occured
    }
    procedure ListSQLFiles(const Folder: String);
    { synchronize memo when user select type of list in combobox
    Parameter: No- 0.. order in combobox list
    }
    procedure ViewSQLFileNameByOrder(No: Integer);
    {}
    function ViewList: Boolean;
    procedure UpdateDisplayLabels;
    procedure RmInfoChanByService;
    procedure MkInfoChanByService;
  protected
  public
    { Public declarations }
    CurHCode  : THCODE;  { }
    CurUPDATER: Longint;  { }
    DEFAULT_DURATION: TDateTime; 
    SQLFolder: SQLPathString;
    PhotoFolder: SQLPathString;
    SQLSYSFolder: SQLPathString;
    SQLVOCFolder: SQLPathString;
    Use_Alias: Boolean;
    DbAliasName,
    DbDriverName: String[32];
    DataBaseFolder,
    WorkPlace: SQLPathString;
    SearchCategory: Integer;

    TableNameClient,
    TableNameVisits,
    TableNameCalls,
    TableNameCAPs,
    TableNamePagers,
    TableNameService,
    TableNameServDesc,
    TableNamePayee,
    TableNameGroups,
    TableNameCli2Emp,
    TableNameEmployee: String[32];
    procedure ETShowStatus(Level: Integer; const S: String);
    { store changes to INI file }
    function  LoadIni: Boolean;
    procedure StoreIniChanges;
    procedure UpdateDBCBs;
    { change alias and update all visibles }
    function AssignAlias(const AAlias: String): Boolean;
    function AssignDataFolder(const ADataFolder: String): Boolean;
    procedure ChangeDataBaseAliasOrFolder;
    { do smth to find DLLS.
    For example, change current directory?
    }
    procedure AssignWorkPlace(const S: String);
    procedure AssignAllTables(const AClient, AVisits, ACalls, ACaps,
      AServ, AServDesc, AService, APayee, AGroups, AEmployee, ACli2Emp: String);
    procedure StoreFields(const S: String);
    function  LoginUser(ASessionInserted: LongInt; AHCode: THCODE;
      AUPDATER: LongInt): Boolean;
    procedure ActivateTables;
    procedure ViewNavigateAbonent;
    function FindAbonent(const Abon: String): Boolean;
  end;

var
  FormClient: TFormClient;

procedure ViewVisitorTable(ASessionInserted: LongInt; var AHCode: THCODE;
  AUPDATER: LongInt);
{$IFNDEF DLLTEST}
export;
{$ENDIF}

implementation
uses
  Visit_2, clogin, Osetting, ServEdit, newabno,
  MoreInfo, CDatas, RelsEdit, EmplForm;

procedure ViewVisitorTable(ASessionInserted: LongInt; var AHCode: THCODE;
  AUPDATER: LongInt);
begin
  FormClient:= TFormClient.Create(Application);
  with FormClient do begin
    if LoginUser(ASessionInserted, AHCode, AUPDATER) then begin
      ShowModal;
      Hide;
    end;
    Free;
  end;
end;

{$R *.DFM}

procedure TFormClient.TNVisChange(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
begin
  AllreadyRegistered:= False;
  BRegister.Enabled:= True;
end;

procedure TFormClient.ETShowStatus(Level: Integer; const S: String);
begin
  with StatusBar1, Panels[3] do begin 
    case Level of
    1:Font.Color:= clRed;
    2:Font.Color:= clBlue;
    3:Font.Color:= clYellow;
    else Font.Color:= clBlack;
    end;
    Caption:= S;
  end;
end;

procedure TFormClient.BSQLDoItClick(Sender: TObject);
begin
  if MSQL.Lines.Count = 0 then begin
    ETShowStatus(1, '       ');
  end else begin
     if ViewList
     then;
  end;
end;

procedure TFormClient.CBSQLsChange(Sender: TObject);
begin
  {}
  ViewSQLFileNameByOrder(CBSQLs.ItemIndex);
end;

procedure TFormClient.Timer1Timer(Sender: TObject);
begin
  { turn off message after Interval 2000 ms = 2s
  }
  ETShowStatus(0, '');
end;

procedure TFormClient.popPhotoDeleteClick(Sender: TObject);
begin
  { clear photo
  }
end;

procedure TFormClient.UpdateVisibles(Sender: TObject);
begin
  { update time }
  { if database has not time type like px4
  LUpdTime.Caption:= TimeToStr(Table1.FieldByName(VisFieldName(FLDVIS,3)).AsInteger / TIMECONV);
  }
 {DEBUG-------------------------------------------------------------------}
 {
  StatusBar1.Panels[1].Text:= DateToStr(DataModule1.TableClient.FieldByName('UPDATED').AsDateTime)+
    TimeToStr(DataModule1.TableClient.FieldByName('UPDTIME').AsDateTime);
    }
end;

procedure TFormClient.BPrintListClick(Sender: TObject);
begin
  PrintDBGrid(DBGQuery);
end;

procedure TFormClient.FillDBCB(const SQLFN: String; List: TStrings; const ACaption: String);
var
  UsedFolder: SQLPathString;
begin
  case MOptionsQuickDictUse.Checked of
  True:  UsedFolder:= SQLVOCFolder;
  False: UsedFolder:= SQLSYSFolder;
  end;
  with DataModule1.Query1 do begin
    Close;
    SQL.LoadFromFile(ConcatPath(UsedFolder, SQLFN));
    Open;
    List.Clear;
    with DataModule1 do while not Query1.EOF do begin
      List.Add(Query1.Fields[0].AsString);
      Query1.Next;
    end;
  end;
  if AboutBox <> Nil then begin
    AboutBox.LLoading.Caption:= ' : '+ ACaption;
  end else begin
    StatusBar1.Panels[3].Text:= ' : '+ ACaption;
  end;
  Application.ProcessMessages;
end;

procedure TFormClient.UpdateDBCBs;
begin
  try
    FillDBCB(SQLBUSINESS, DBCBBusiness.Items, ' ');
    FillDBCB(SQLVENTURES, DBCBOrgName.Items, '');
    FillDBCB(SQLMODEL, DBCBPgModel.Items, ' ');
    FillDBCB(SQLINFOCHANNELS, DBGInfoChannels.Columns[0].PickList, 'CAP-  ');
    FillDBCB(SQLMANUF, DBCBReseller.Items, ' ');
    FillDBCB(SQLDEFECT, DBCBRepairDesc.Items, '   ');
    FillDBCB(SQLEMPL, DBCBRepairMan.Items, '  ');
    FillDBCB(SQLCITY, DBCBCity.Items, ' ()');
    FillDBCB(SQLBILL, DBCBBillName.Items, ' / ');
    FillDBCB(SQLDOC, DBCBDOCNAME.Items, ' ');
    FillDBCB(SQLSERVICE, DBCBServiceCat.Items, ' ');
    { EmplForm }
    with FormEmployee do begin
      FillDBCB(SQLSPECIALITY, DBCBSpeciality.Items, '');
      FillDBCB(SQLDOLZ, DBCBDolz.Items, '');
      FillDBCB(SQLNATION, DBCBNation.Items, '');
      FillDBCB(SQLCATEG, DBCBCateg.Items, '');
      FillDBCB(SQLBLOCK, DBCBBlock.Items, '/');
      FillDBCB(SQLDEPARTMENT, DBCBDepartment.Items, '');
      FillDBCB(SQLPHONE, DBCBPhone.Items, '');
      FillDBCB(SQLSUBJ1, CBAim.Items, ' ');
      // FillDBCB(SQLSUBJ2, CBAim.Items, ' ');      
    end;
  except
    ShowMessage('      .');
  end;
end;

function TFormClient.AssignAlias(const AAlias: String): Boolean;
var
  i: Integer;
begin
  AssignAlias:= False;
  if AAlias <> '' then with DataModule1,Database1 do begin
    {     }
    Connected:= False;
    {      }
    for i:= 0 to ALLTABLES-1
    do CDatas.Tables[i].DataBaseName:= DataBase1.DataBaseName;
    for i:= 0 to ALLQUERIES-1
    do CDatas.Queries[i].DataBaseName:= DataBase1.DataBaseName;
    DriverName:= '';    // first
    AliasName:= AAlias; // second
    AssignAlias:= True;
  end;
end;

function TFormClient.AssignDataFolder(const ADataFolder: String): Boolean;
var
  i: Integer;
begin
  AssignDataFolder:= False;
  with DataModule1 do if ADataFolder <> '' then begin
    Database1.Connected:= False;
    Database1.AliasName:= '';
    DataBase1.Params.Values['PATH']:= ADataFolder;
    DataBase1.Params.Values['SERVER NAME']:= ADataFolder;
    DataBase1.DriverName:= DbDriverName;
    { connect others }
    for i:= 0 to ALLTABLES-1 do begin
      // CDatas.Tables[i].Active:= False;
      CDatas.Tables[i].DatabaseName:= DataBase1.DataBaseName;
      // CDatas.Tables[i].TableName:= '';
    end;
    for i:= 0 to ALLQUERIES-1 do begin
      // CDatas.Queries[i].Active:= False;
      CDatas.Queries[i].DatabaseName:= DataBase1.DataBaseName;
    end;
    AssignDataFolder:= True;
  end;
end;

procedure TFormClient.ChangeDataBaseAliasOrFolder;
var
  i: Integer;
begin
  if Use_Alias then begin
    AssignAlias(DbAliasName);
  end else begin
    AssignDataFolder(DataBaseFolder);
  end;
  AssignAllTables(
      TableNameClient,
      TableNameVisits,
      TableNameCalls,
      TableNameCAPs,
      TableNamePagers,
      TableNameServDesc,
      TableNameService,
      TableNamePayee,
      TableNameGroups,
      TableNameEmployee,
      TableNameCli2Emp
    );

  CDatas.DataModule1.Database1.Open;
  if CDatas.DataModule1.Database1.Connected then begin
    for i:= 0 to ALLTABLES-1
    do CDatas.Tables[i].Active:= True;
    CDatas.DataModule1.QueryServ.Active:= True;
  end;
end;

procedure TFormClient.AssignWorkPlace(const S: String);
begin
  if S = '' then begin
    if DEFWORKPLACE <> ''
    then ChDir(DEFWORKPLACE);
  end else begin
    ChDir(S);
  end;
end;

procedure TFormClient.AssignAllTables(const AClient, AVisits, ACalls, ACaps,
  AServ, AServDesc, AService, APayee, AGroups, AEmployee, ACli2Emp: String);
var
  i: Integer;
begin
  for i:= 0 to ALLTABLES-1
  do CDatas.Tables[i].Active:= False;
  for i:= 0 to ALLQUERIES-1
  do CDatas.Queries[i].Active:= False;
  with DataModule1 do begin
    TableNameClient:= ExtractFileName(AClient);
    TableClient.TableName:= TableNameClient;
    TableNameVisits:= ExtractFileName(AVisits);
    TableVisits.TableName:= TableNameVisits;
    TableNameCalls:= ExtractFileName(ACalls);
    TableCalls.TableName:= TableNameCalls;
    TableNamePayee:= ExtractFileName(APayee);
    TablePayee.TableName:= TableNamePayee;
    TableNameGroups:= ExtractFileName(AGroups);
    TableGroups.TableName:= TableNameGroups;
    TableNameCAPs:= ExtractFileName(ACAPs);
    TableCAPs.TableName:= TableNameCAPs;
    TableNamePagers:= ExtractFileName(AServ);
    TablePagers.TableName:= TableNamePagers;
    TableNameService:= ExtractFileName(AService);
    TableService.TableName:= TableNameService;
    TableNameServDesc:= ExtractFileName(AServDesc);
    TableServDesc.TableName:= TableNameServDesc;
    TableNameEmployee:= ExtractFileName(AEmployee);
    TableEmployee.TableName:= TableNameEmployee;
    TableNameCli2Emp:= ExtractFileName(ACli2Emp);
    TableCli2Emp.TableName:= TableNameCli2Emp;
  end;
end;

procedure TFormClient.StoreFields(const S: String);
begin
  { not implemented }
end;

procedure ValidateDateDelimiters(var S: ShortString);
begin
  {     ,    ,  }
  if Length(S) = 1
  then S:= S+S;
  {        ,  }
  if Length(S) = 0
  then S:= DEFDATEDELIMITERS;
  {     (   2),   }
  System.Delete(S, 3, 255);
end;

procedure ValidatePhoneDelimiter(var S: ShortString);
begin
  {        ,  }
  if Length(S) = 0
  then S:= DEFPHONEDELIMITER;
  {     (   1),   }
  System.Delete(S, 2, 255);
end;

function TFormClient.LoadIni: Boolean;
var
  i: Integer;
  IniFile: TIniFile;
begin
  IniFile:= TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with DataModule1, IniFile do begin
    DataBase1.Close;
    for i:= 0 to ALLTABLES-1
    do CDatas.Tables[i].DisableControls;
    Font.Name:= ReadString(sectFONT, iniFontName, 'System');
    {  tabset    }
    TNVis.TabFont.Name:= Font.Name;
    TabSetVisits.Font.Name:= Font.Name;
    TabSetCalls.Font.Name:= Font.Name;
    TabSetSearch.Font.Name:= Font.Name;
    Font.Size:= ReadInteger(sectFONT, iniFontSize, -10);
    {     }
    CDatas.SQLTrigger:= ReadBool(sectGLOBAL, iniSQLTRIGGER, False);
    Use_Alias:= ReadBool(sectGLOBAL, iniUSEALIAS, True);
    DbAliasName:= ReadString(sectGLOBAL, iniALIAS, 'PAGER');
    DbDriverName:= ReadString(sectGLOBAL, iniDriverName, 'STANDARD');
    DataBaseFolder:= ReadString(sectGLOBAL, iniDataFolder, 'DATA\');
    TableNameClient:= ReadString(sectCLIENTS, iniCLILTBL, 'Client');
    TableNameVisits:= ReadString(sectVISITS, iniVISITSTBL, 'Visits');
    TableNameCalls:= ReadString(sectCALLS, iniCALLSTBL, 'Calls');
    TableNamePayee:= ReadString(sectPAYEE, iniPAYEETBL, 'Payee');
    TableNameGroups:= ReadString(sectGROUPS, iniGROUPSTBL, 'Groups');
    TableNameCAPs:= ReadString(sectCAPS, iniCAPsTBL, 'CAPs');
    TableNameServDesc:= ReadString(sectSERVDESC, iniSERVDESCTBL, 'ServDesc');
    TableNamePagers:= ReadString(sectPAGER, iniPAGERSTBL, 'Pagers');
    TableNameService:= ReadString(sectSERV, iniSERVTBL, 'Service');
    TableNameEmployee:= ReadString(sectEMPLOYEE, iniEMPLTBL, 'Employee');
    TableNameCli2Emp:= ReadString(sectCLI2EMP, iniCLI2EMPTBL, 'Cli2Emp');
    WorkPlace:= ReadString(sectGLOBAL, iniDLLS, DEFWORKPLACE);
    {      - ,  }
    ReadSectionValues(sectDBParams, DataBase1.Params);
    DataBase1.LoginPrompt:= ReadBool(sectGLOBAL, iniLoginPrompt, True);
    { folders }
    AssignWorkPlace(WorkPlace);
    PhotoFolder:= ReadString(sectGLOBAL, iniPHOTOS, 'PHOTO\');
    SQLFolder:= ReadString(sectGLOBAL, iniSQLS, 'SQL\');
    FLBoxSQL.Mask:= (ConCatPath(SQLFolder, '*.SQL'));
    SQLSYSFolder:= ReadString(sectGLOBAL, iniSYSSQLS, 'SQL\SYS\');
    SQLVOCFolder:= ReadString(sectGLOBAL, iniVOCSQLS, 'SQL\VOC\');

    MOptionsQuickDictUse.Checked:= ReadBool(sectGLOBAL, iniSYSSQLS, False);
    AutoSexDetect:= ReadBool(sectGLOBAL, iniAUTOSEXDETECT, True);
    ChangeDataBaseAliasOrFolder;
    { VISITORLABELS }
    CLIENTLABELS:= ReadString(sectCLIENTS, iniCLIENTLABELS, DEFCLILABELS);
    { Visits detailed table labels }
    VISITSLABELS:= ReadString(sectVISITS, iniVISITSLABELS, DEFVSSLABELS);
    CALLSLABELS:= ReadString(sectCALLS, iniCALLSLABELS, DEFCALLABELS);
    {}
    MoreInfo.DocumentFolder:= ReadString(sectCLIENTS, iniDOCUMENTFOLDER, DEFDOCUMENTFOLDER);
    ActivateTables;
    {     
          }
    {     ?          }
    ValidateDateDelimiters(DATEDELIMITER);
    {      -   }
    ValidatePhoneDelimiter(PHONEDELIMITER);
  end;
  IniFile.Free;
  LoadIni:= True;
end; { LoadIni }

procedure TFormClient.StoreIniChanges;
var
  IniFile: TIniFile;
begin
  {   }
  StoreIniServiceList;
  IniFile := TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with DataModule1, IniFile do begin
    WriteString(sectFONT, iniFontName, Font.Name);
    WriteInteger(sectFONT, iniFontSize, Font.Size);
    WriteBool(sectGLOBAL, iniSQLTRIGGER, CDatas.SQLTrigger);
    WriteBool(sectGLOBAL, iniUSEALIAS, Use_Alias);
    WriteString(sectGLOBAL, iniALIAS, DbAliasName);
    WriteString(sectGLOBAL, iniDriverName, DbDriverName);
    WriteString(sectGLOBAL, iniDATAFOLDER, DataBaseFolder);
    WriteString(sectGLOBAL, iniDLLS, '');
    WriteString(sectGLOBAL, iniSQLS, SQLFolder);
    WriteString(sectGLOBAL, iniSYSSQLS, SQLSYSFolder);
    WriteString(sectGLOBAL, iniVOCSQLS, SQLVOCFolder);
    WriteBool(sectCLIENTS, iniUseVOCCLI, MOptionsQuickDictUse.Checked);
    WriteBool(sectGLOBAL, iniAUTOSEXDETECT, AutoSexDetect);
    { firstly change fields, adn then - table must be changed }
    StoreFields(CLIDEFAULTFIELDFILE);
    WriteString(sectCLIENTS, iniCLILTBL, ExtractFileName(TableClient.TableName));
    WriteString(sectVISITS, iniVISITSTBL, ExtractFileName(TableVisits.TableName));
    WriteString(sectCALLS, iniCALLSTBL, ExtractFileName(TableCalls.TableName));
    WriteString(sectPAYEE, iniPAYEETBL, ExtractFileName(TablePAYEE.TableName));
    WriteString(sectGROUPS, iniGROUPSTBL, ExtractFileName(TableGROUPS.TableName));
    WriteString(sectCAPs, iniCAPsTBL, ExtractFileName(TableCAPs.TableName));
    WriteString(sectPAGER, iniPAGERSTBL, TableNamePagers);
    WriteString(sectSERV, iniSERVTBL, TableNameService);
    WriteString(sectSERVDESC, iniSERVDESCTBL, TableNameServDesc);
    WriteString(sectEMPLOYEE, iniEMPLTBL, TableNameEmployee);
    WriteString(sectCli2Emp, iniCli2EmpTBL, TableNameCli2Emp);
    { VISITORLABELS }
    WriteString(sectCLIENTS, iniCLIENTLABELS, CLIENTLABELS);
    WriteString(sectVISITS, iniVISITSLABELS, VISITSLABELS);
    {      }
    ValidateDateDelimiters(DATEDELIMITER);
    {      -  
    }
    ValidatePhoneDelimiter(PHONEDELIMITER);
    {  }
    {  }
    WriteString(sectGLOBAL, iniPHONEDELIMITER, PHONEDELIMITER);
    {  }
    WriteString(sectGLOBAL, iniDATEDELIMITERS, DATEDELIMITER);
  end;
  IniFile.Free;
end;

procedure TFormClient.TabSetSearchChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  i: Integer;
  len: Integer;
begin
  with DbGSearchVisitor do begin
    AllowChange:= DataSource.Dataset.Active;
    if AllowChange then with DataSource.Dataset do begin
      DisableControls;
      case NewTab of
      1: begin
           Len:= 8;
         end;
      2: begin
           Len:= 6;
         end;
      else begin
           Len:= 10;
         end;
      end;
      for i:= 1 to FieldCount do begin
        Fields[i-1].DisplayWidth:= Len;
      end;
      EnableControls;
    end;
  end;
end;

procedure TFormClient.BevelStyle(Id: Word);
begin
  Bevel2.BevelOuter:= bvRaised;
  Bevel3.BevelOuter:= bvRaised;
  Bevel4.BevelOuter:= bvRaised;
  case Id of
  0:  Bevel2.BevelOuter:= bvLowered;
  1:  Bevel3.BevelOuter:= bvLowered;
  2:  Bevel4.BevelOuter:= bvLowered;
  end;
end;

procedure TFormClient.ToggleSearch1(Sender: TObject);
begin
  {}
  SearchCategory:= SEARCHBYNAMES;
  BevelStyle(SEARCHBYNAMES);
end;

procedure TFormClient.ToggleSearch2(Sender: TObject);
begin
  {}
  SearchCategory:= SEARCHBYID;
  BevelStyle(SEARCHBYID);
end;

procedure TFormClient.ToggleSearch3(Sender: TObject);
begin
  {}
  SearchCategory:= SEARCHBYDATE;
  BevelStyle(SEARCHBYDATE);
end;

procedure TFormClient.BSearchClick(Sender: TObject);
begin
  {  HCODE   
  }
  with DataModule1.TableClient do case SearchCategory of
    SEARCHBYNAMES: begin
      IndexName:= TblFieldName(INDCLI+'0');
      FindNearest([MEFAM.Text, MEIM.Text,MEOT.Text]);
    end;
    SEARCHBYID   : begin
      IndexName:= TblFieldName(INDCLI+'1');
      FindNearest([MEOrgName.Text, MEOrgNo.Text]);
    end;
    SEARCHBYDATE : begin
      IndexName:= TblFieldName(INDCLI+'2');;
      FindNearest([MEBillName.Text, MEBillSer.Text,MEBillDog.Text]);
    end;
  end;
end;

procedure TFormClient.BNewVisitorClick(Sender: TObject);
begin
  with DataModule1.TableClient do begin
    Insert;
    Edit;
    FieldByName(TblFieldName(FLDCLI+'5')).AsString:= MEFAM.Text;
    FieldByName(TblFieldName(FLDCLI+'6')).AsString:= MEIM.Text;
    FieldByName(TblFieldName(FLDCLI+'7')).AsString:= MEOT.Text;
    FieldByName(TblFieldName(FLDCLI+'13')).AsString:= MEOrgName.Text;
    FieldByName(TblFieldName(FLDCLI+'12')).AsString:= MEOrgNo.Text;
    FieldByName(TblFieldName(FLDCLI+'41')).AsString:= MEBillName.Text;
    FieldByName(TblFieldName(FLDCLI+'39')).AsString:= MEBillSer.Text;
    FieldByName(TblFieldName(FLDCLI+'40')).AsString:= MEBillDog.Text;
    Post;
  end;
  TNVis.PageIndex:= tbCARD;
end;

procedure TFormClient.TableVisitorAfterInsert(DataSet: TDataset);
begin
  {          
    SQL ,    
  }
  { next counter value }
  Inc(SessionInserted);
  with DataModule1.TableClient do begin
    { hcode }
    FieldByName(TblFieldName(FLDCLI+'0')).AsString:= CurHCODE;
    { updater }
    FieldByName(TblFieldName(FLDCLI+'1')).AsInteger:= CurUpdater;
    { updated }
    FieldByName(TblFieldName(FLDCLI+'2')).AsDateTime:= Date;
    { update time }
    { if no time type in database use next operator
    FieldByName(TblFieldName(FLDVIS,3)).AsInteger:= Trunc(Time * TIMECONV);
    }
    FieldByName(TblFieldName(FLDCLI+'3')).AsDateTime:= Time;
    { update session no }
    FieldByName(TblFieldName(FLDCLI+'4')).AsInteger:= SessionInserted;
    { sex }
    FieldByName(TblFieldName(FLDCLI+'10')).AsString:= TblFieldName(MSGSTR+'2');
    { birth }
    FieldByName(TblFieldName(FLDCLI+'8')).AsDateTime:= Date - 25 * 365;
    { docname }
    FieldByName(TblFieldName(FLDCLI+'11')).AsString:= TblFieldName(MSGSTR+'4');
    { docser }
    FieldByName(TblFieldName(FLDCLI+'12')).AsString:= TblFieldName(MSGSTR+'5');
    { docnum }
    FieldByName(TblFieldName(FLDCLI+'13')).AsString:= TblFieldName(MSGSTR+'6');
    { docdate }
    FieldByName(TblFieldName(FLDCLI+'14')).AsDateTime:=  Date - 16 * 365;
    { dockem }
    FieldByName(TblFieldName(FLDCLI+'15')).AsString:=  TblFieldName(MSGSTR+'7');
    { FID }
    FieldByName(TblFieldName(FLDCLI+'16')).AsString:=  TblFieldName(MSGSTR+'0');
    { MID }
    FieldByName(TblFieldName(FLDCLI+'21')).AsString:=  TblFieldName(MSGSTR+'1');
    { MWORK }
    FieldByName(TblFieldName(FLDCLI+'25')).AsString:=  TblFieldName(MSGSTR+'8');
    { city }
    FieldByName(TblFieldName(FLDCLI+'27')).AsString:=  TblFieldName(MSGSTR+'9');
    { local }
    FieldByName(TblFieldName(FLDCLI+'31')).AsString:=  TblFieldName(MSGSTR+'10');
    { org }
    FieldByName(TblFieldName(FLDCLI+'35')).AsString:=  TblFieldName(MSGSTR+'11');
    { orgname }
    FieldByName(TblFieldName(FLDCLI+'36')).AsString:=  TblFieldName(MSGSTR+'12');
    { policname }
    FieldByName(TblFieldName(FLDCLI+'38')).AsString:=  TblFieldName(MSGSTR+'13');
    { record created }
    FieldByName(TblFieldName(FLDCLI+'42')).AsDateTime:= Date;
    Post;  { store autoincrement field to master field }
  end;
  { create first record in detailed table VISITS - AfterInsert event }
  {
  TableVisits.Append;
  }
end;

procedure TFormClient.TableVisitorCalcFields(DataSet: TDataset);
begin
  UpdateVisibles(Self);
end;

procedure TFormClient.TableVisitsAfterInsert(DataSet: TDataset);
begin
  {          
    SQL ,    
  }
  with DataModule1.TableVisits do begin
    { I hope that related fields are similar in both tables }
    { hcode }
    FieldByName(TblFieldName(FLDCLI+'0')).AsString:= CurHCODE;
    { updater }
    FieldByName(TblFieldName(FLDCLI+'1')).AsInteger:= CurUpdater;

    { updated time (midnight, remember) }
    FieldByName(TblFieldName(FLDCLI+'2')).AsDateTime:=
      Date;
    { update time (use master record not Time func) }
    FieldByName(TblFieldName(FLDCLI+'3')).AsDateTime:=
      Time;
    { update session no }
    FieldByName(TblFieldName(FLDCLI+'4')).AsInteger:= SessionInserted;
    { autoincrement field copy to the related table VISITS }
    { visits.INTERNAL(1) -> visitor.INTERNAL(43) }
    FieldByName(TblFieldName(FLDVSS+'1')).AsInteger:=
      DataModule1.TableClient.FieldByName(TblFieldName(FLDCLI+'43')).AsInteger;
    {
    Post;
    }
  end;
end;

procedure TFormClient.EditOTChange(Sender: TObject);
begin
  {    '' -   }
  if AutoSexDetect then with DataModule1.TableClient do begin
    if State = dsEDIT then begin
      if LastChar(DBENameO.Text) in ['','']
      then FieldByName(TblFieldName(FLDCLI+'10')).AsString:= TblFieldName(MSGSTR+'1')  { '' }
      else FieldByName(TblFieldName(FLDCLI+'10')).AsString:= TblFieldName(MSGSTR+'0'); { '' }
    end;
  end;
end;

procedure TFormClient.BRegisterClick(Sender: TObject);
begin
  if (not AllreadyRegistered) and (FormNewVisit <> Nil) then begin
    with FormEmployee do begin
      if ShowModal = mrOk then begin
        AllreadyRegistered:= True;
       { hide this button }
        BRegister.Enabled:= False;
      end else BRegister.Enabled:= True;
    end;
  end;
  DataModule1.TableVisits.Refresh;
end;

procedure TFormClient.DSVisitsDataChange(Sender: TObject; Field: TField);
begin
  {   }
  StatusBar1.Panels[2].Text:= IntToStr(DataModule1.TableVisits.RecordCount);
end;

function  TFormClient.LoginUser(ASessionInserted: LongInt; AHCode: THCODE;
   AUPDATER: LongInt): Boolean;
begin
  SessionInserted:= ASessionInserted;
  CurHCode:= AHCode;
  CurUpdater:= AUPDATER;
  LoginUser:= True;
end;

procedure TFormClient.ListSQLFiles(const Folder: String);
var
  i: Integer;
begin
  CBSQLs.Items.Clear;
  for i:= 1 to FLBoxSQL.Items.Count do begin
    CBSQLs.Items.Add(GetFileLine(ConCatPath(SQLFolder,FLBoxSQL.Items[i-1]), 2));
  end;
end;

procedure TFormClient.ViewSQLFileNameByOrder(No: Integer);
begin
  FLBoxSQL.ItemIndex:= No;
  MSQL.Lines.LoadFromFile(ConCatPath(SQLFolder,FLBoxSQL.Items[No]));
end;

function TFormClient.ViewList: Boolean;
begin
  ViewList:= True;
  with DataModule1 do begin
    if MSQL.Lines.Count = 0 then begin
      { no SQL, nothing to do
      }
    end else begin
      { try to execute SQL query
      }
      { turn off previous sql
      }
      Query1.Close;
      { try do it
      }
      Query1.SQL.Assign(MSQL.Lines);
      try
        if Use_Alias then begin
          Query1.Open;
        end else begin
         { ChDir(EDBFolder.Text); }
         Query1.Open;
         { ChDir(WorkPlace); }
        end;
      except
        ViewList:= False;
        ETShowStatus(1, '  ');
      end;
    end;
  end;
end;

procedure TFormClient.DBETmpStreetChange(Sender: TObject);
begin
  { temp address }
  with DataModule1 do begin
    if TableClient.State = dsEdit
    then TableClient.FieldByName(TblFieldName(FLDCLI+'31')).AsString:= 'x';
  end;
end;

procedure TFormClient.TableVisitorBeforeDelete(DataSet: TDataset);
begin
  { delete record in VISITS table by INTERNAL field }
  with DataModule1.TableVisits do while not EOF do begin
    Delete;
  end;
end;

procedure TFormClient.FormActivate(Sender: TObject);
begin
  if FirstActivate then begin
    try
      ActiveControl:= DBENameF;
    except
    end;
    Application.OnHint:= DisplayHint;
    Application.HintPause:= 8 * 1000;
    FirstActivate:= False;
  end;
end;

procedure TFormClient.UpdateDisplayLabels;
var
  i: Integer;
begin
  { dbgrid labels }
  with DataModule1 do begin
    with TableClient do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', CLIENTLABELS);
        end;
      end;
    end;
    if TableVisits.Active then begin
      for i:= 1 to TableVisits.FieldCount do begin
        TableVisits.Fields[i-1].DisplayLabel:= GetToken(i, ',', VISITSLABELS);
      end;
    end;
    if TableCalls.Active then begin
      for i:= 1 to TableCalls.FieldCount do begin
        TableCalls.Fields[i-1].DisplayLabel:= GetToken(i, ',', CALLSLABELS);
      end;
    end;
    {
    if TablePayee.Active then begin
      for i:= 1 to TablePayee.FieldCount do begin
        TablePayee.Fields[i-1].DisplayLabel:= GetToken(i, ',', PAYEELABELS);
      end;
    end;
    if TableGroups.Active then begin
      for i:= 1 to TableGroups.FieldCount do begin
        TableGroups.Fields[i-1].DisplayLabel:= GetToken(i, ',', GROUPSLABELS);
      end;
    end;
    if TableCAPs.Active then begin
      for i:= 1 to TableCAPs.FieldCount do begin
        TableCAPs.Fields[i-1].DisplayLabel:= GetToken(i, ',', CAPSLABELS);
      end;
    end;
    TableServDesc.
    }
  end;
end;

procedure TFormClient.FormDestroy(Sender: TObject);
begin
  EraseServiceList;
end;

procedure TFormClient.DtDBEDateKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key >= #32) and not (Key in ['0'..'9'])
  then begin
    if Pos(DATEDELIMITER[1],DtDBEBirth.Text) > 0
    then Key:= DATEDELIMITER[2]
    else Key:= DATEDELIMITER[1];
  end
end;

procedure TFormClient.DtDBEWhenKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Key >= #32) and not (Key in ['0'..'9'])
  then begin
    if Pos(DATEDELIMITER,DtDBEWhen.Text) > 0
    then Key:= DATEDELIMITER[2]
    else Key:= DATEDELIMITER[1];
  end
end;

procedure TFormClient.DBEPhoneKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Key >= #32) and not (Key in ['0'..'9'])
  then Key:= PHONEDELIMITER[1];
end;

procedure TFormClient.DBGSearchVisitorDblClick(Sender: TObject);
begin
  TNVis.PageIndex:= 0;
end;

procedure TFormClient.FatherNameClick(Sender: TObject);
var
  Sex: String[1];
  lastchar: String[1];
  glasnaja: Boolean;
  S: String;
begin
  with DataModule1 do begin
    if DSClient.State = dsEdit then with TableCLIENT do begin
      {       }
      S:= FieldByName(TblFieldName(FLDCLI+'18')).AsString;
      { if nothing do nothing }
      if S = ''
      then Exit;
      Sex:= System.Copy(FieldByName(TblFieldName(FLDCLI+'10')).AsString,1,1);
      LastChar:= System.Copy(S, Length(S), 1);
      glasnaja:= LastChar[1] in ['','','','','','','','',''];
      { delete last char if .. }
      {
      if glasnaja
      then System.Delete(S[, Length(S), 1);
      }
      if glasnaja then begin
        {   ,    }
        if (Length(S)>1) and (S[Length(S)-1] = '')
        then S[Length(S)-1]:= '';
        S[Length(S)]:= '';
      end else S:= S+'';

      if (FieldByName(TblFieldName(FLDCLI+'7')).AsString = '') or (
        MessageDlg(' ?',
        mtInformation, [mbYes, mbNo], 0) = mrYes)
      then begin
        case Sex[1] of
         'M', 'm', '','': begin
           FieldByName(TblFieldName(FLDCLI+'7')).AsString:= S + '';
         end else begin
             FieldByName(TblFieldName(FLDCLI+'7')).AsString:= S + '';
         end;
        end;
      end;
    end;
  end;
end;

procedure TFormClient.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := True;
  with DataModule1 do begin
    if (DSClient.State in [dsEdit]) or
      (DSVisits.State in [dsEdit]) then begin
      if MessageDlg(': c   ?', mtConfirmation,
        [mbOk, mbCancel], 0) = mrOK then begin
        CanClose := True;
        with TableVisits do if State = dsEdit
        then Post;
        with TableCalls do if State = dsEdit
        then Post;
        with TablePayee do if State = dsEdit
        then Post;
        with TableGroups do if State = dsEdit
        then Post;
        with TableCAPs do if State = dsEdit
        then Post;
        with TablePagers do if State = dsEdit
        then Post;
        with TableService do if State = dsEdit
        then Post;
        with TableServDesc do if State = dsEdit
        then Post;
        with TableClient do if State = dsEdit
        then Post;
      end else begin
        CanClose := False;
      end;
    end;
  end;
end;

procedure TFormClient.TabSetVisitsChange(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
var
  i: Integer;
  len: Integer;
begin
  with DbGridVisits do begin
    AllowChange:= DataSource.Dataset.Active;
    if AllowChange then with DataSource.Dataset do begin
      DisableControls;
      case NewTab of
      1: Len:= 7;
      2: Len:= 5;
      else Len:= 9;
      end;
      for i:= 1 to FieldCount do begin
        Fields[i-1].DisplayWidth:= Len;
      end;
      EnableControls;
    end;
  end;
end;

procedure TFormClient.FormCreate(Sender: TObject);
begin
  TNVis.PageIndex:= 0;
  ServicesSet:= [];
  {    .  ,   }
  AliasCyrList:= TStringList.Create;
  SearchCategory:= SEARCHBYNAMES;
  AllreadyRegistered:= False;
  SessionInserted:= 1;
  CurHCode  := 'SPC';
  CurUPDATER:= 0;
  DEFAULT_DURATION:= 5/(24*60); { 5' }
  FirstActivate:= True;
end;

procedure TFormClient.TabSetCallsChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  i: Integer;
  len: Integer;
begin
  with DbGCalls do begin
    AllowChange:= DataSource.Dataset.Active;
    if AllowChange then with DataSource.Dataset do begin
      DisableControls;
      case NewTab of
      1: Len:= 7;
      2: Len:= 5;
      else Len:= 9;
      end;
      for i:= 1 to FieldCount do begin
        Fields[i-1].DisplayWidth:= Len;
      end;
      EnableControls;
    end;
  end;
end;

procedure TFormClient.DisplayHint(Sender: TObject);
begin
  StatusBar1.Panels[3].Text:= Application.Hint;
end;

procedure TFormClient.ActivateTables;
var
  i: Integer;
begin
  UpdateDisplayLabels;
  ListSQLFiles('');
  {    .,     }
  with DataModule1 do begin
    for i:= 0 to CDatas.ALLTABLES -1
    do CDatas.Tables[i].EnableControls;
  end;  
end;

procedure TFormClient.MFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormClient.BEditRelationsClick(Sender: TObject);
begin
  if FormEditRelsList.ShowModal = mrOK
  then;
end;

procedure TFormClient.BAddServiceClick(Sender: TObject);
begin
  with DataModule1 do begin
    if TableServDesc.IsEmpty
    then Exit;
    if TableService.State = dsEDIT
    then TableService.Post;
    TableService.Append;
    TableService.FieldByName('HCODE').AsString:= TableClient.FieldByName('HCODE').AsString;
    TableService.FieldByName('ABONENT').AsString:= TableClient.FieldByName('ABONENT').AsString;
    TableService.FieldByName('SERVICE').AsInteger:= TableServDesc.FieldByName('SERVICE').AsInteger;
    TableService.Post;
    //  
    with QueryServ do begin
      Close;
      Open;
    end;
  end;
end;

procedure TFormClient.BSubServiceClick(Sender: TObject);
begin
  with DataModule1 do begin
    if TableService.IsEmpty
    then Exit;
    if TableService.State = dsEDIT
    then TableService.Post;
    //      TableService
    TableService.First;
    while not TableService.EOF do begin
      if TableService.FieldByName('SERVICE').AsString =
        QueryServ.FieldByName('SERVICE').AsString
      then Break;
      TableService.Next;
    end;
    //  
    TableService.Delete;
    //  
    with QueryServ do begin
      Close;
      Open;
    end;
  end;
end;

procedure TFormClient.ViewNavigateAbonent;
var
  Ab: String;
begin
  with DataModule1.TableClient do begin
    Ab:= FieldByName('ABONENT').AsString;
    CBSearch.Text:= Ab + #32 +
      FieldByName('FAM').AsString + #32 +
      FieldByName('IM').AsString+ #32 + FieldByName('OT').AsString;
    // 
    // Combobox1.Items.
    if MoreInfo.FormMoreInfoOnScreen then begin
      //       (  )
      FormMoreInfo.GotoAbonent(Ab);
    end;
  end;
end;

function TFormClient.FindAbonent(const Abon: String): Boolean;
var
  A, F, I, O: String;
begin
  with DataModule1.TableClient do begin
    A:= GetToken(1, #32, Abon);
    if isDecimal(A) then begin
      IndexName:= '';
      FindNearest([CurHCODE, A]);
    end else begin
      F:= GetToken(1, #32, Abon);
      I:= GetToken(2, #32, Abon);
      O:= GetToken(3, #32, Abon);
      IndexName:= TblFieldName(INDCLI+'0');
      FindNearest([F, I, O]);
    end;
    ViewNavigateAbonent;
  end;
  FindAbonent:= True;
end;

procedure TFormClient.CBSearchKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  #13: begin
         if FindAbonent(CBSearch.Text) then begin
           if CBSearch.Items.IndexOf(CBSearch.Text) < 0 then begin
             if CBSearch.Items.Count >= CBSearch.DropDownCount
             then CBSearch.Items.Delete(CBSearch.Items.Count-1);
             CBSearch.Items.Add(CBSearch.Text);
           end;  
         end;
         Key:= #0;
       end;
  end;
end;

procedure TFormClient.BChangeAbNoClick(Sender: TObject);
begin
  {   
  }
  FormNewAbNo:= TFormNewAbNo.Create(Application);
  with FormNewAbNo do begin
    if ShowModal = mrOK
    then ViewNavigateAbonent;
  end;
  FormNewAbNo.Free;
end;

//       
procedure TFormClient.MkInfoChanByService;
var
  CurBCast,
  CurCAP: String[32];
begin
  RmInfoChanByService;
  with DataModule1 do begin
    QueryServ.DisableControls;
    CurCAP:= TableClient.FieldByName('CAP').AsString;
    // 
    if QueryServ.State = dsEDIT
    then QueryServ.Post;
    QueryServ.First;
    while not QueryServ.EOF do begin
      // SERVDESC.CAP - cap   (BCAST)
      CurBCast:= QueryServ.FieldByName('CAP').AsString;
      try
        if CurBCast > #32 then begin
          DataModule1.TableCAPS.InsertRecord(
            [CurCAP, CurBCast, QueryServ.FieldByName('CHAN').AsInteger]);
        end;
      except
        //    
      end;
      QueryServ.Next;
    end;
    QueryServ.EnableControls;    
  end;
end;

procedure TFormClient.RmInfoChanByService;
begin
  //  ?
  with DataModule1.TableCAPS do begin
    DisableControls;
    if State = dsEDIT
    then Post;
    First;
    while not EOF do begin
      Delete;
    end;
    EnableControls;
  end;
end;

procedure TFormClient.TBMkInfoChanByServiceClick(Sender: TObject);
begin
  MkInfoChanByService;
end;

procedure TFormClient.TBRmInfoChanByServiceClick(Sender: TObject);
begin
  RmInfoChanByService;
end;

procedure TFormClient.HeaderControl1SectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  DBGServiceDescList.Width:= HeaderControl1.Sections[0].Width+2;
  Toolbar2.Width:= HeaderControl1.Sections[1].Width+2;
  DBGAbServices.Width:= HeaderControl1.Sections[2].Width+2;
end;

procedure TFormClient.BMoreInformationClick(Sender: TObject);
begin
  {   
  }
  if MoreInfo.FormMoreInfoOnScreen then begin
    FormMoreInfo.Free;
  end else begin
    FormMoreInfo:= TFormMoreInfo.Create(Application);
    FormMoreInfo.Font.Name:= Font.Name;
    FormMoreInfo.Show;
  end;
end;

procedure TFormClient.MCommonOptionsClick(Sender: TObject);
begin
  FormSettings:= TFormSettings.Create(Application);
  FormSettings.Font.Name:= FormClient.Font.Name;
  FormSettings.Set2Alias(DbAliasName, DataBaseFolder,DbDriverName,Use_Alias,DataModule1.Database1);
  if FormSettings.ShowModal = mrOK then begin
    if FormSettings.FontChanged then begin
      {}
      with FormSettings do begin
        FormClient.Font:= Font;
        { tabs control }
        TNVis.TabFont.Name:= Font.Name;
        TabSetVisits.Font.Name:= Font.Name;
        TabSetCalls.Font.Name:= Font.Name;
        TabSetSearch.Font.Name:= Font.Name;
        {    visits }
        { //     
        if FormNewVisit <> Nil
        then FormNewVisit.Font.Name:= Font.Name;
        }
      end;
    end;
    if FormSettings.DBLocationChanged then begin
      Use_Alias:= FormSettings.RGByAlias.Checked;
      DbDriverName:= FormSettings.CBDbDriver.Text;
      DbAliasName:= FormSettings.CBAlias.Text;
      DataBaseFolder:= FormSettings.EDBFolder.Text;
      ChangeDataBaseAliasOrFolder;
      ActivateTables;
    end;
  end;
  FormSettings.Free;
end;

procedure TFormClient.MOptionsQuickDictUseClick(Sender: TObject);
begin
  {      ini   
          combobox'
  }
  {         }
  with FormClient do begin
    MOptionsQuickDictUse.Checked:= not MOptionsQuickDictUse.Checked;
  end;
end;

procedure TFormClient.MOptionsStoreClick(Sender: TObject);
begin
  StoreIniChanges;
end;

procedure TFormClient.MOptionsUpdateDictClick(Sender: TObject);
begin
  UpdateDBCBs;
end;

{       }
procedure TFormClient.MViewShowPasswdClick(Sender: TObject);
begin
  MViewShowPasswd.Checked:= not MViewShowPasswd.Checked;
  if MViewShowPasswd.Checked then begin
    DBEPasswd.PasswordChar:= #0;
  end else begin
    DBEPasswd.PasswordChar:= '*';
  end;
end;

procedure TFormClient.CBSearchClick(Sender: TObject);
begin
  {  }
  (Sender as TCombobox).Perform(CB_ShowDropDown, Ord(True), 0);
end;

procedure TFormClient.MViewEmployeeClick(Sender: TObject);
begin
  FormEmployee.Visible:= not FormEmployee.Visible;
end;

end.
