unit newabno;
(*##*)
(*******************************************************************
*                                                                 *
*   N  E  W  A  B  N  O    Client, EPAGER's unit.                  *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   form to assign new abonent's id                               *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 218                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Mask, DBCtrls, ComCtrls, db;

type
  TFormNewAbNo = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    BAutoMkNum: TButton;
    OKBtn: TButton;
    EStart: TEdit;
    UDStart: TUpDown;
    Label2: TLabel;
    Label1: TLabel;
    Memo1: TMemo;
    EAbonent: TEdit;
    UpDown2: TUpDown;
    procedure BAutoMkNumClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure StoreNewNo(ANewNo: String);
    procedure ChangeAbNo(const Tbl, VOld, VNew: String);
  end;

var
  FormNewAbNo: TFormNewAbNo;

implementation

uses CDatas, Client;

{$R *.DFM}

procedure TFormNewAbNo.ChangeAbNo(const Tbl, VOld, VNew: String);
begin
  //if Tbl.DS.State = dsEdit
  // then Post;
  //      HCODE;ABONENT
  with DataModule1.query1 do begin
    Close;
    SQL.Clear;
    SQL.Text:= 'UPDATE '+Tbl+ ' SET ABONENT = "'+ VNew +
      '" WHERE ABONENT = "'+ VOld +'";';
    ExecSQL;
  end;
  {
  with Tbl do begin
    First;
    while not EOF do begin
      //        HCODE;ABONENT
      if FieldByName('ABONENT').AsString = VOld then begin
        Edit;
        FieldByName('ABONENT').AsString:= VNew;
        Post;
      end;
      Next;
    end;
  end;
  }
end;

procedure TFormNewAbNo.StoreNewNo(ANewNo: String);
var
  AOldNo: String;
begin
  with DataModule1.TableClient, FormClient do begin
    // 
    // FindKey([FormClient.CurHCode, AOldNo]);
    //      
    //
    AOldNo:= FieldByName('ABONENT').AsString;
    ChangeAbNo(TableNameGroups, AOldNo, ANewNo);
    ChangeAbNo(TableNamePayee, AOldNo, ANewNo);
    ChangeAbNo(TableNameCalls, AOldNo, ANewNo);
    ChangeAbNo(TableNameVisits, AOldNo, ANewNo);
    ChangeAbNo(TableNameService, AOldNo, ANewNo);
    //    
    Edit;
    FieldByName('ABONENT').AsString:= ANewNo;
    Post;
  end;
end;

procedure TFormNewAbNo.BAutoMkNumClick(Sender: TObject);
begin
  EAbonent.Text:= IntToStr(DataModule1.MkNewAbonentNumber(UDStart.Position));
end;

procedure TFormNewAbNo.OKBtnClick(Sender: TObject);
begin
  StoreNewNo(EAbonent.Text);
end;

procedure TFormNewAbNo.FormCreate(Sender: TObject);
begin
  EAbonent.Text:= DataModule1.TableClient.FieldByName('ABONENT').AsString;
end;

end.
