unit DModule;
(*##*)
(*******************************************************************
*                                                                 *
*   D  M  O  D  U  L  E        EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Invisible component storage (Operator project)                *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 80                                              *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, ExtCtrls,
  AdTapi, AdTStat, AdPort, AdSModem, DdeMan,
  Util1;

type
  TDataModule1 = class(TDataModule)
    QDict: TQuery;
    TableClient: TTable;
    TableCalls: TTable;
    DSDict: TDataSource;
    DSClient: TDataSource;
    DSCalls: TDataSource;
    Database1: TDatabase;
    TableGroups: TTable;
    DSGroups: TDataSource;
    TableGrpDesc: TTable;
    DSGrpDesc: TDataSource;
    ImageList1: TImageList;
    TablePagers: TTable;
    DSPagers: TDataSource;
    TableModels: TTable;
    DSModels: TDataSource;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    ImageList2: TImageList;
    SaveDialog1: TSaveDialog;
    ComPort: TApdComPort;
    TapiDev: TApdTapiDevice;
    TapiStatus: TApdTapiStatus;
    TapiLog: TApdTapiLog;
    convOperator: TDdeServerConv;
    itemAbonent: TDdeServerItem;
    ImageList3: TImageList;
    procedure TableGrpDescBeforeDelete(DataSet: TDataSet);
    procedure Timer1Timer(Sender: TObject);
    procedure DataModule1Create(Sender: TObject);
    procedure convOperatorExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    { Private declarations }
  public
    { Public declarations }
    StepCount: Word;
    DBBusy: Word; //   
  end;

//     
function KeepLinkCallBack(Tag: String): String; far;

var
  DataModule1: TDataModule1;

implementation

uses
  Oper;

{$R *.DFM}

procedure TDataModule1.TableGrpDescBeforeDelete(DataSet: TDataSet);
begin
  {         
  }
  with TableGroups do begin
    DisableControls;
    {    }
    if (DSGroups.State in [dsEdit])
    then Post;
    {      }
    if FindFirst then begin
      while not EOF do begin
        Delete;
        if not FindNext
        then Break;
      end;
    end;
    EnableControls;
  end;
end;

procedure TDataModule1.Timer1Timer(Sender: TObject);
begin
  // ..
  with ImageList2 do begin
    GetIcon(StepCount and (ImageList2.Count-1), Application.Icon);
    if DBBusy=0 then begin
      Inc(DBBusy);
      try
        with FormOper do begin
          Icon.Assign(Application.Icon);
          if FormOper.TabSetMessages.TabIndex <> 0 then begin
            TableCalls.Refresh;
            ShowIsSent(0);
          end;
        end;
      finally
        Dec(DBBusy);
      end;
    end;
  end;
  Inc(StepCount);
end;

procedure TDataModule1.DataModule1Create(Sender: TObject);
begin
  StepCount:= 0;
  DBBusy:= 0;
end;

//     
function KeepLinkCallBack(Tag: String): String; far;
begin
  Result:= '';
end;


procedure TDataModule1.convOperatorExecuteMacro(Sender: TObject; Msg: TStrings);
var
  S: String;
begin
  {}
  FormOper.ETShowStatus(0, ' ');
  S:= Msg.Text;
  //  
  ReplaceTag(S, '<', '>', #0, KeepLinkCallBack);
  DeleteControlsStrCRLF2Space(S);
  FormOper.MMessage.Text:= S;
end;

end.
