program EOper;
(*##*)
(*******************************************************************
*                                                                 *
*   E  O  P  E  R              EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*                                                                 *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 1641                                            *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)
uses
  Forms,
  PCommon,
  util1,
  About in '..\ABOUT.PAS' {AboutBox},
  Oper in 'OPER.PAS' {FormOper},
  Osetting in '..\OSETTING.PAS' {FormSettings},
  Osearch in 'OSEARCH.PAS' {FormSearch},
  Clogin in '..\CLOGIN.PAS' {FormLogin},
  DModule in 'DModule.pas' {DataModule1: TDataModule},
  Group in 'Group.pas' {FormGroups},
  ViewAbon in 'ViewAbon.pas' {FormAbonents},
  AbMsgLst in 'AbMsgLst.pas' {FormClientMessages},
  typist in 'typist.pas',
  OpSets in 'OpSets.pas' {FormOperSettings},
  Voices in 'Voices.pas' {FormVoices},
  optapi in 'optapi.pas';

{$R *.RES}
begin
  AboutBox:= TAboutBox.Create(Application);
  AboutBox.Show;
  AboutBox.Update;
  Application.ProcessMessages;
  { .   }
  CyrDates;
  CreateServiceList;
  Application.HelpFile := 'Employ.hlp';
  Application.CreateForm(TFormOper, FormOper);
  Application.CreateForm(TFormSearch, FormSearch);
  Application.CreateForm(TDataModule1, DataModule1);
  Application.CreateForm(TFormGroups, FormGroups);
  Application.CreateForm(TFormAbonents, FormAbonents);
  Application.CreateForm(TFormClientMessages, FormClientMessages);
  AboutBox.Hide;
  AboutBox.Free;
  AboutBox:= Nil;
  if LoginScreen(FormOper.CurUPDATER, FormOper.CurHcode)
  then Application.Run;
end.

