unit DModule;
(*##*)
(*******************************************************************
*                                                                 *
*   E  G  A  T  E.  D  M  O  D  U  L  E EPAGER's unit.             *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   EGATE unit containing data access unvisible components        *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 100                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, ExtCtrls, ImgList;

type
  //  callback   .  False ()
  //          
  TTimerIdleFunc =  function: Boolean;

  TDataModule1 = class(TDataModule)
    QDict: TQuery;
    TableModels: TTable;
    DSDict: TDataSource;
    DSModels: TDataSource;
    DSCalls: TDataSource;
    Database1: TDatabase;
    TableGroups: TTable;
    DSGroups: TDataSource;
    TableGrpDesc: TTable;
    DSGrpDesc: TDataSource;
    TableClient: TTable;
    DSClient: TDataSource;
    OpenDialog1: TOpenDialog;
    TablePagers: TTable;
    DSPagers: TDataSource;
    ImageList1: TImageList;
    TableCALLS: TTable;
    Timer1: TTimer;
    ImageList2: TImageList;
    procedure TableCALLSFilterRecord(DataSet: TDataSet;
      var Accept: Boolean);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModule1: TDataModule1;
const
  //          
  //  Nil,   
  //             
  TimerIdle: TTimerIdleFunc = Nil;

implementation

uses
  EQ, Cycles;

{$R *.DFM}

procedure TDataModule1.TableCALLSFilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
begin
{ SELECT CALLS.* FROM CALLS
  WHERE (DELIVERED <> :PDELIVERED) AND
       ((ZONE IN (:PZONES)) OR (ZONE IS NULL))
  ORDER BY SKIND, SSTART
}
 //     -  ,  BDE   
  with Dataset do begin
  Accept:= ((FieldByName('DELIVERED').IsNull) or
    (FieldByName('DELIVERED').AsString[1] in [#32, 'o', ch_BUSY])) and
    ((FieldByName('ZONE').IsNull) or
    (FormQueue.IsInZoneList(Dataset.FieldByName('ZONE').AsString)));
    // (   'o')-   ('b'- ), x- 
  end;
end;

procedure TDataModule1.Timer1Timer(Sender: TObject);
var
  r: Boolean;
begin
  {     }
  if @TimerIdle <> Nil then begin
    r:= TimerIdle;
  end;
end;


end.
