program
  Ini2SQL;
(*##*)
(******************************************************************
*                                                                 *
*                                                                 *
*                       I  N  I  2  S  Q  L                       *
*                                                                 *
*   TEXT utility (c) 1992-1997, A. Ivanov. All rights reserved    *
*   read .INI - like file and create SQL script to insert values  *
*     ;Example of .INI file:                                      *
*     [VOC]                                                       *
*     "Record1 Field 1" "Field2" Field3                           *
*   Last Revision: Mar 09 1998                                    *
*   Last fix     : Mar 09 1998                                    *
*   Lines        : ---                                            *
*   Printed      : ---                                            *
*                                                                 *
*******************************************************************)
(*##*)

uses
  Objects, dos, crt,
  vgaxdecl, strutil;

const
  COPYRIGHT = '';
  BUFSIZE   = 4096;
  LASTBUFFSTRING = 31;
  DelimiterContinue: Boolean = False;
  DELIMITERS: set of Char =[#0..'/', ':'..'@','['..'`','{'..#127,#176..#223,#253..#255];
  LASTCHAPTER: Word = 1024;
var
  FN: FNameStr;
  Len: LongInt;
  ft, outputf: Text;

procedure Syntax;
begin
  Writeln(#13#10'⠪: '+ ProgramName + '< 䠩>');
  Writeln('< 䠩> - 室 䠩');
end;

procedure Parse;
var
  i, j: Integer;
  S: String;
begin
  if (ParamCount > 1) or (ParamCount <1) then begin
    Syntax;
    Halt(2);
  end;
  FN:= ParamStr(1);
  if not Exist(FN) then begin
    Syntax;
    Halt(2);
  end;
end;

procedure OpenRes;
begin
  Assign(outputf, '');
  Rewrite(outputf);
  if IOResult <> 0 then begin
    Writeln('訡  室 䠩 ');
    Halt(3);
  end;
end;

procedure DoIT2;
var
  i: Longint;
  Ups, root, s: String;
  L, p: Word;
  chpos: Word;
  firsttime: Boolean;
  chapS: String[12];
  line: LongInt;
begin
  ClrEOL;
  line:= 0;
  firsttime:= true;
  while not EOF(FT) do begin
    Readln(FT, Buf^.S[0]);
    Inc(Line);
    if (line and $FF) = $FF then begin
      GotoXY(1, WhereY); Write('ப: ',line:8);
    end;
    chpos:= Pos(#9, Buf^.S[0]);
    ProcessChapter:= chpos > 0;
    if ProcessChapter then begin
      s:= Copy(Buf^.S[0], chpos+1, 255);
      {   㤠  ⭮ ஫稬  ᫨     }
      Val(s, ChapterNo, L);
      {  Processchapter  ஢塞  Chapterno }
      { ᫨ Chapterno = 0   㪠⥫ }
      { 㤠 뫪  ⠡樥 }
      Delete(Buf^.S[0], chpos, 255);
    end;
    { 뢠    㯮ॡ ᫮ }
    Inc(ChapterPtr^[ChapterNo]);
    {   ᠬ ᫮ - ய }
    Ups:= UpcaseStr(Buf^.S[0]);
    if Ups = UpcaseStr(Buf^.S[1])
    then Continue;
    L:= Length(Buf^.S[0]);
    root:= Buf^.S[0];
    { 㤠 䨪     ⪨ ᫮ }
    if L > SUFFIXLEN1 then begin
      Delete(root, L-(SUFFIXLEN1-1), SUFFIXLEN1);
    end else root:= Copy(root, 1, 2);
    if (Buf^.S[0][1] in [#0..'?']) or (L <= SUFFIXLEN1) or (UpcaseStr(Buf^.S[0]) = UpcaseStr(Buf^.S[1])) then begin
    end else begin
      if firsttime or (
         (StackPtr < LASTBUFFSTRING-1) and
          ( Pos(Copy(Buf^.S[2], 1, Length(Buf^.S[2])-SUFFIXLEN1), root ) = 1)
         ) then begin
        {  ᫮ }
        Inc(StackPtr);
        Buf^.S[StackPtr]:= Buf^.S[0];
        firsttime:= false;
      end else begin
        { 뢥  ᫮ }
        S:= Buf^.S[2] + ' ';
        for i:= 3 to StackPtr do begin
          p:= Length(Buf^.S[i])-(SUFFIXLEN1-1);
          if UpperCase(Buf^.S[i][p])
            = UpperCase(Buf^.S[2][p])
          then s:= s + '-' + Copy(Buf^.S[i], p, SUFFIXLEN1-1) + ';'
          else s:= s + '-' + Copy(Buf^.S[i], p-1, SUFFIXLEN1) + ';';
        end;
        { 뢥 뫪 }
        S:= S + #9;
        for i:= 1 to LASTCHAPTER do begin
          if ChapterPtr^[i] > 0 then begin
            Str(i, ChapS);
            S:= S + ChapS +','#32;
          end;
          if S[0] > #128 then begin
            { ப  ᪮筠 }
            Write(outputf, S);
            S:= '';
          end;
        end;
        { 㤠 ᫥     ᥣ }
        {
        L:= length(S);
        if (S[L-1] = ',') and (S[L] = #32)
        then Delete(S, L-1, 2);
        }
        { ⮪ ப }
        Writeln(outputf, S);
        Buf^.S[2]:= Buf^.S[0];
        StackPtr:= 2;
        {  稪  ᫮   }
        FillChar(ChapterPtr^, (LASTCHAPTER+1)*SizeOf(WORD), #0);
      end;
      Buf^.S[1]:= Buf^.S[0];
    end;
  end;
  GotoXY(1, WhereY); Write('ࠡ⠭ ப: ',line:8);
end;

procedure CloseRes;
begin
  Close(outputf);
end;

begin
  Writeln(COPYRIGHT);
  Parse;
  OpenRes;
  DoIt;
  CloseRes;
  Writeln;
end.