unit DatMod;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DdeMan, EDdeMan, ImgList;

type
  TDM = class(TDataModule)
    Timer1: TTimer;
    ImageList1: TImageList;
    procedure DdeClientItem1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure DMCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    EDdeClientConv1: TEDdeClientConv;
    EDdeClientItem1: TEDdeClientItem;
    EDdeServerConv1: TEDdeServerConv;
    EDdeServerItem1: TEDdeServerItem;
    EDdeServerConv2: TEDdeServerConv;
    EDdeServerItem2: TEDdeServerItem;
    EDdeServerConv3: TEDdeServerConv;
    EDdeServerItem3: TEDdeServerItem;
    EDdeServerConv4: TEDdeServerConv;
    EDdeServerItem4: TEDdeServerItem;
  end;

var
  DM: TDM;

implementation

uses tapnull;

{$R *.DFM}

procedure TDM.DdeClientItem1Change(Sender: TObject);
var
  i: Integer;
begin
  for i:= 1 to EDdeClientItem1.Lines.Count do begin
    FormTAPNull.Memo1.Lines.Add(FormatDateTime('hh:nn:ss  ', Time) + EDdeClientItem1.Lines[i-1]);
  end;
end;

procedure TDM.Timer1Timer(Sender: TObject);
begin
  FormTAPNull.ViewState;
end;

procedure TDM.DMCreate(Sender: TObject);
begin
  EDdeClientConv1:= TEDdeClientConv.Create(self);
  EDdeClientConv1.ConnectMode:= ddeManual;

  EDdeClientItem1:= TEDdeClientItem.Create(self);
  EDdeClientItem1.DdeConv:= EDdeClientConv1;

  EDdeServerConv1:= TEDdeServerConv.Create(self);
  EDdeServerItem1:= TEDdeServerItem.Create(self);
  EDdeServerItem1.ServerConv:= EDdeServerConv1;

  EDdeServerConv2:= TEDdeServerConv.Create(self);
  EDdeServerItem2:= TEDdeServerItem.Create(self);
  EDdeServerItem2.ServerConv:= EDdeServerConv2;

  EDdeServerConv3:= TEDdeServerConv.Create(self);
  EDdeServerItem3:= TEDdeServerItem.Create(self);
  EDdeServerItem3.ServerConv:= EDdeServerConv3;

  EDdeServerConv4:= TEDdeServerConv.Create(self);
  EDdeServerItem4:= TEDdeServerItem.Create(self);
  EDdeServerItem4.ServerConv:= EDdeServerConv4;
  {     }
end;

end.
