;
; script to send data to TAP terminal
; EOT ^d
; ACK ^f  CR  ^m  LF  ^j  NAK ^u  ESC ^[
;
;
;Set options
initport com2 9600

set log off
set trace off

set retry 1                ;no retries
set writeanyway            ;overwrite incoming file

:no_carrier
display '^m^j[ ..]^m^j'
send atz^m                 ;
wait ok 4                  ;

set log flush
set trace flush
set log off
set trace off

if fail error              ;

if cd carrier_detect
display '^m^j '
goto no_carrier
:carrier_detect
display '^m^j '

display '^m^j[ ..]^m^j'
;send atm1dp260-9726^m     ;

display '^m^j[ ..]^m^j'
set retry 3                ;3   3   CR
send ^m
wait 'ID=' 3
if fail error

set retry 1
display '^m^j[..]^m^j'
send ^[PG1^m
waitmulti ^m^f^m|^m^u^m|^m^[^d^m 1
if fail error
if 2 error
if 3 error

set retry 1
display '^m^j[   ..]^m^j'
wait ^[[p^m 10
if fail error

set retry 1
:blockloop
display '^m^j[ ..]^m^j'
if nextblock doblock
display '^m^j[  , ..]^m^j'
;        4 
send ^d^m
waitmulti ^[^d^m|^^^m 4
if fail error
if 2 error

goto noblocks
:doblock
sendblock
waitmulti ^m^f^m|^m^u^m|^m^^^m|^m^[^d 4
if fail error
if 4 error                  ; 
                            ; 3-    ,   
if 2 blockloop

:noblocks
display '^m^j[OK!]^m^j'
goto end

:error
display '^m^j[!]^m^j'

:end