unit unipg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Grids, DBGrids, DBTables, ComCtrls, Menus, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    StatusBar1: TStatusBar;
    pmR_TYPE: TPopupMenu;
    N1numericdisplay1: TMenuItem;
    N1: TMenuItem;
    N5Talkback2way1: TMenuItem;
    N8displayvoice1: TMenuItem;
    Btonealertenhanced2alhpadisplay1: TMenuItem;
    numericdisplayenhanced3voice1: TMenuItem;
    DAlphadisplayenhanced1: TMenuItem;
    pm_R_MSG: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    BGolay1: TMenuItem;
    CObsoletedigital1: TMenuItem;
    pmR_FLAGS: TPopupMenu;
    AA1: TMenuItem;
    AA2: TMenuItem;
    AA3: TMenuItem;
    AA4: TMenuItem;
    N2: TMenuItem;
    R1: TMenuItem;
    L1: TMenuItem;
    P1: TMenuItem;
    X1: TMenuItem;
    pmR_ZONE: TPopupMenu;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    N3: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    N11: TMenuItem;
    N112: TMenuItem;
    N113: TMenuItem;
    N6BC1: TMenuItem;
    N7AB1: TMenuItem;
    N8D1: TMenuItem;
    N9AD1: TMenuItem;
    EBCD1: TMenuItem;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    procedure pmr_typeclick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure pmr_msgclick(Sender: TObject);
    procedure pmR_FLAGSClick(Sender: TObject);
    procedure pmR_ZONEClick(Sender: TObject);
  private
    { Private declarations }
    procedure DisplayHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnHint:= DisplayHint;
end;

procedure TForm1.DisplayHint(Sender: TObject);
begin
  with StatusBar1
  do Panels[Panels.Count-1].Text:= Application.Hint;
end;

procedure TForm1.pmr_typeclick(Sender: TObject);
var
  Ch: Char;
begin
  with Sender as TMenuItem do begin
    Ch:= Caption[2];
    with Table1 do begin
      Edit;
      FieldByName('R_TYPE').AsString:= Ch;
      Post;
    end;
  end;
end;

procedure TForm1.pmr_msgclick(Sender: TObject);
var
  Ch: Char;
begin
  with Sender as TMenuItem do begin
    Ch:= Caption[2];
    with Table1 do begin
      Edit;
      FieldByName('R_MSG').AsString:= Ch;
      Post;
    end;
  end;
end;

procedure TForm1.pmR_ZONEClick(Sender: TObject);
var
  Ch: Char;
begin
  with Sender as TMenuItem do begin
    Ch:= Caption[2];
    with Table1 do begin
      Edit;
      FieldByName('R_ZONE').AsString:= Ch;
      Post;
    end;
  end;
end;

procedure TForm1.pmR_FLAGSClick(Sender: TObject);
var
  Ch: Char;
  S: String;
  p: Integer;
begin
  //   12 , - 
  with Sender as TMenuItem do begin
    Ch:= Caption[2];
    with Table1 do begin
      S:= FieldByName('R_FLAGS').AsString;
      p:= Pos(Ch, S);
      if p  > 0
      then System.Delete(S, p, 1)
      else S:= S + Ch;
      Edit;
      FieldByName('R_FLAGS').AsString:= S;
      Post;
    end;
  end;
end;

procedure TForm1.DBGrid1CellClick(Column: TColumn);
var
  S: String;
begin
  with Column do begin
    S:= '';
    if FieldName = 'R_SUBID'
    then S:= '   000000  999999   0000  9999-  ( "">0)';
    if FieldName = 'R_CHANNEL'
    then S:= ' ,      ';
    if FieldName = 'R_ZONE'
    then S:= '    ( 4- )   ';
    if FieldName = 'R_TYPE'
    then S:= ' - 1:2 2:5 6:overdial 7:.. 8:HSC 9:NECD3 A:POCSAG B:GOLAY C:Obsol.dig';
    if FieldName = 'R_MSG'
    then S:= '  0: 1:0-9 2:A-Z 3:Voice 4:V-alert 5:Talk-back2 8:A-Z+Voice B:tone2alpha C:0-93voice D:A-Z enh';
    if FieldName = 'R_CAPCODE'
    then S:= ' CAP  0000000  9999999 ( cap-    )';
    if FieldName = 'R_FUNC'
    then S:= 'function code (pager subaddress)     1  4';
    if FieldName = 'R_FLAGS'
    then S:= ' , A-D- , E-H-  ., R-   , L-   P- X- ';
    if FieldName = 'R_ACCOUNT'
    then S:= '    0  9999999';
    if FieldName = 'R_RATE'
    then S:= '  (  )';
    if FieldName = 'R_SERVICE'
    then S:= ' 8     ';
    if FieldName = 'R_ADD'
    then S:= '- 0: 1:  2-9:  20-89:.';
    if FieldName = 'R_GROUP'
    then S:= ' - 1-9999: .     0:  ';
    if FieldName = 'R_GMASTER'
    then S:= 'True:  .   False:   ';
    if FieldName = 'R_NOTES'
    then S:= '   ( 56 )';
    if FieldName = 'R_SDATE'
    then S:= '  ( )';
    if FieldName = 'R_MDATE'
    then S:= '   ( )';
    if FieldName = 'R_CALLCNT'
    then S:= '  ()  0  99999';
    if FieldName = 'R_LASTCNT'
    then S:= '      0  99999';
    if FieldName = 'R_SERIAL'
    then S:= '   ( 16 )  -   (M-Motorola)';
    if FieldName = 'R_IMAGEA'
    then S:= '  (12 )    ';
    if FieldName = 'R_IMAGEB'
    then S:= '  (14 )    ';
    if FieldName = 'R_IMAGEM'
    then S:= '    Message manager ( .)';
    DBGrid1.Hint:= S;
  end;
end;

end.
