unit Visit_2;
(*##*)
(*******************************************************************
*                                                                 *
*   V  I  S  I  T  _  2     Client, EPAGER's unit.                 *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Part of client project. Register form                         *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 218                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, DBLookup, StdCtrls, Mask,
  DBCtrls, ExtCtrls, Tabs, TabNotBk,
  Client, ComCtrls;

type
  TFormNewVisit = class(TForm)
    procedure TableEmployeeFInitialesGetText(Sender: TField;
      var Text: OpenString; DisplayText: Boolean);
    procedure TableEmployeeFInitialesSetText(Sender: TField;
      const Text: String);
  private
    { Private declarations }
    AliasUsed: boolean;
    DBFolder: String;
    procedure VisitsUpdateDisplayLabels;
  public
    { Public declarations }
  end;

var
  FormNewVisit: TFormNewVisit;
{
const
  ALLVISITSFORTHISID   = 'SQL\SQL101.SQL';
  EMPLOYEESHORT        = 'SQL\SQL102.SQL';
  LASTUPDATE           = 'SQL\SQL103.SQL';
  }
implementation

{$R *.DFM}
uses
  IniFiles,
  PCommon, util1;

var
  HOSPITALLABELS: String[255];
  EMPLOYEESHORTLABELS: String[255];

procedure TFormNewVisit.VisitsUpdateDisplayLabels;
begin
end;

procedure TFormNewVisit.TableEmployeeFInitialesGetText(Sender: TField;
  var Text: OpenString; DisplayText: Boolean);
var
  I, O: String[2];
begin
  {
  I:= System.Copy(TableEmployee.FieldByName(TblFieldName(FLDEMP+'3')).AsString, 1,1);
  O:= System.Copy(TableEmployee.FieldByName(TblFieldName(FLDEMP+'4')).AsString, 1,1);
  Text:= TableEmployee.FieldByName(TblFieldName(FLDEMP+'2')).AsString +
    ' ' +  I + '.' + O + '.';
  }
end;

procedure TFormNewVisit.TableEmployeeFInitialesSetText(Sender: TField;
  const Text: String);
var
  S: String;
  p: Integer;
begin
  {     }
  S:= text;
  {   }
  p:= Pos('.', S);
  if p > 0 then System.Delete(S, p, 255);
  {
  TableEmployee.FieldByName(TblFieldName(FLDEMP+'2')).AsString:= S;
  }
end;

end.
