unit AbMsgLst;
(*##*)
(*******************************************************************
*                                                                 *
*   A  B  M  S  G  L  S  T     EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Abonent's list (part of Operator project)                     *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 46                                              *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, ExtCtrls;

type
  TFormClientMessages = class(TForm)
    DBGridCalls: TDBGrid;
    Panel2: TPanel;
    procedure Form2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    oldx, oldy: Integer;
  public
    { Public declarations }
  end;

var
  FormClientMessages: TFormClientMessages;

implementation

uses
  DModule, Oper, PCommon;

{$R *.DFM}

procedure TFormClientMessages.Form2MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if FormOper.MViewHotAreas.Checked then begin
    if (MouseMoveDir(x, y, oldx, oldy) and 8) = 8
    then Hide;
  end;
end;

procedure TFormClientMessages.FormActivate(Sender: TObject);
begin
  oldx:= 0;
  oldy:= 0;
end;

end.
