unit ViewAbon;
(*##*)
(*******************************************************************
*                                                                 *
*   V  I  E  W  A  B  O  N     EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   View abonent's list. Part of Operator project                 *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 70                                              *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, DBGrids, Menus;

type
  TFormAbonents = class(TForm)
    DBGClients: TDBGrid;
    PopMenu2: TPopupMenu;
    MEditEnabled: TMenuItem;
    Panel1: TPanel;
    procedure DBGClientsCellClick(Column: TColumn);
    procedure MEditEnabledClick(Sender: TObject);
    procedure MWindowBottomClick(Sender: TObject);
    procedure MWindowLeftClick(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    oldx,
    oldy: Integer;
  public
    { Public declarations }
  end;

var
  FormAbonents: TFormAbonents;

implementation

uses DModule, Oper, PCommon;

{$R *.DFM}

procedure TFormAbonents.DBGClientsCellClick(Column: TColumn);
begin
  FormOper.SearchCategory:= 1;
  FormOper.CustomerSelected;
end;

procedure TFormAbonents.MEditEnabledClick(Sender: TObject);
begin
  DBGClients.ReadOnly:= not DBGClients.ReadOnly;
  MEditEnabled.Checked:= not DBGClients.ReadOnly;
end;

procedure TFormAbonents.MWindowBottomClick(Sender: TObject);
begin
  {}
end;

procedure TFormAbonents.MWindowLeftClick(Sender: TObject);
begin
  {}
end;

procedure TFormAbonents.Panel1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  {}
 if FormOper.MViewHotAreas.Checked then begin
    if (MouseMoveDir(x, y, oldx, oldy) and 8) = 8
    then Hide;
  end;
end;

procedure TFormAbonents.FormActivate(Sender: TObject);
begin
  oldx:= 0;
  oldy:= 0;
end;

end.
