unit
  CPImport;
(*##*)
(*******************************************************************
*                                                                 *
*   C  P  I  M  P  O  R  T                                       *
*                          Part of XLAT1                          *
*   Copyright (c) 1998, A.Ivanov. All rights reserved.             *
*                                                                 *
*   Conditional defines:                                           *
*                                                                 *
*   Last Revision: Oct 05 1998                                     *
*   Last fix     : Oct 05 1998                                    *
*   Lines        : 43                                              *
*   History      :                                                *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  cpcoll;

type
  TFormImportCP = class(TForm)
    BOk: TButton;
    BCancel: TButton;
    CBInUse: TCheckBox;
    GBSigns: TGroupBox;
    CBFlagL: TCheckBox;
    CBFlagC: TCheckBox;
    CBFlagLL: TCheckBox;
    CBFlagCC: TCheckBox;
    CBFlag1: TCheckBox;
    GroupBox1: TGroupBox;
    ECP: TEdit;
    ECPBase: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    CBCPNames: TComboBox;
    procedure CBCPNamesClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CPDefs: PCPDefinitions;
  end;

var
  FormImportCP: TFormImportCP;

implementation

{$R *.DFM}

procedure TFormImportCP.CBCPNamesClick(Sender: TObject);
begin
  if CPDefs = Nil
  then Exit;
  CBInUse.Checked:= pgt_used in CPDefs^[CBCPNames.ItemIndex].Flags;
  CBFlag1.Checked:= pgt_num in CPDefs^[CBCPNames.ItemIndex].Flags;
  CBFlagLL.Checked:= pgt_latU in CPDefs^[CBCPNames.ItemIndex].Flags;
  CBFlagL.Checked:= pgt_latl in CPDefs^[CBCPNames.ItemIndex].Flags;
  CBFlagCC.Checked:= pgt_cyrU in CPDefs^[CBCPNames.ItemIndex].Flags;
  CBFlagC.Checked:= pgt_cyrl in CPDefs^[CBCPNames.ItemIndex].Flags;
  ECP.Text:= IntToStr(CPDefs^[CBCPNames.ItemIndex].CP);
  ECPBase.Text:= IntToStr(CPDefs^[CBCPNames.ItemIndex].BaseCP);
end;

procedure TFormImportCP.FormActivate(Sender: TObject);
begin
  CBCPNames.ItemIndex:= 0;
  CBCPNamesClick(Self);
end;

end.
